package cz.vsb.fei.efrei.lab04;

import java.util.Random;

public class Monster implements Fighter {

	private static final Random RANDOM = new Random();

	@Order(3)
	@Formatter(length = 15)
	private String name;
	@Order(1)
	@Formatter(length = 5)
	private final int strenght;
	@Order(2)
	@Formatter(length = 4)
	private int lives;
	@Order(1)
	@Formatter(hidden = true)
	private boolean leader = true;

	public Monster(String name, int strenght) {
		if (name == null || name.length() < 2) {
			throw new IllegalArgumentException("Too short name");
		}
		if (strenght < 10) {
			throw new IllegalArgumentException("Monster is too weak!!");
		}
		this.name = name;
		this.strenght = strenght;
		this.lives = 100;
	}

	public Monster(String name) {
		this(name, RANDOM.nextInt(90) + 10);
	}

	@Override
	public void attackedBy(Fighter fighter) {
//		System.out.println(fighter.getName() + " attack " + getName() + "!");
		lives -= fighter.getStrenght();
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public int getStrenght() {
		return strenght;
	}

	@Override
	public int getLives() {
		return lives;
	}

	@Override
	public String toString() {
		return String.format("Monster %20s (%4d) - has %4d lives.", name, strenght, lives);
	}

	@Override
	public int compareTo(Fighter o) {
		return this.getName().compareTo(o.getName());
	}

}
