package cz.vsb.fei.efrei.lab04;

import java.util.ArrayList;
import java.util.List;

public class WorldOfGenericCountries {

	public static void main(String[] args) {
//		Country2 countryOfEvil = new Country2("Mordor");
//		Country2 countryOfBraves = new Country2("Heros from lake of Braves");
//		countryOfEvil.hire(new Hero(Utils.generateHeroName()));
//		countryOfBraves.hire(new Monster(Utils.generateMonsterName()));

		List<Country<? extends Fighter>> countries = new ArrayList<>();

		countries.add(createCountryOfMonsters());
		countries.add(createCountryOfHeros());

		Country<? extends Fighter> c1 = Utils.getRandom(countries);
		Country<? extends Fighter> c2 = Utils.getRandom(countries);
		boolean c1Miss = false;
		boolean c2Miss = false;
		System.out.println(String.format("%20s X %20s", c1.getName(), c2.getName()));
		while (c1.someoneAlive() && c2.someoneAlive()) {
			c1Miss = false;
			c2Miss = false;
			Fighter f1 = choseAliveFighter(c1);
			Fighter f2 = choseAliveFighter(c2);
			try {
				f1.attackedBy(f2);
			} catch (AlreadyDeadException e) {
				c2Miss = true;
			}
			f1 = choseAliveFighter(c1);
			f2 = choseAliveFighter(c2);
			try {
				f2.attackedBy(f1);
			} catch (AlreadyDeadException e) {
				c1Miss = true;
			}
			System.out.print(String.format("%s%s <> %s%s", c1Miss ? "miss" : "    ", c1.getArmyStat(),
					c2Miss ? "miss" : "    ", c2.getArmyStat()));
			System.out.print("\r");
			try {
				Thread.sleep(10);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}

	}

	private static Fighter choseAliveFighter(Country<? extends Fighter> c) {
		Fighter f;
		f = Utils.getRandom(c.getArmy());
		while (!f.isAlive() && c.someoneAlive()) {
			f = Utils.getRandom(c.getArmy());
		}
		return f;
	}

	private static Country<? extends Fighter> createCountryOfMonsters() {
		Country<Monster> countryOfEvil = new Country<>("SoldierGenerator<T> generatorMordor");

		populateArmy(countryOfEvil, new MonsterGenerator(), 200);
		populateArmy(countryOfEvil, new MonsterGenerator2(), 200);
		populateArmy(countryOfEvil, () -> new Monster(Utils.generateMonsterName()), 200);
		return countryOfEvil;
	}

	private static Country<? extends Fighter> createCountryOfHeros() {
		Country<Hero> countryOfBraves = new Country<>("Heros from lake of Braves");
		populateArmy(countryOfBraves, () -> new Hero(Utils.generateHeroName()), 300);
		return countryOfBraves;
	}

	private static <T extends Fighter> void populateArmy(Country<T> country, SoldierGenerator<T> generator, int count) {
		for (int i = 0; i < count; i++) {
			country.hire(generator.generateSoldier());
		}
	}

	public static class MonsterGenerator2 implements SoldierGenerator<Monster> {
		@Override
		public Monster generateSoldier() {
			return new Monster(Utils.generateMonsterName());
		}
	}
}
